#!/bin/bash
set -euo pipefail

source .env

echo "DOCKER_VOLUMES_PATH_PREFIX value: ${DOCKER_VOLUMES_PATH_PREFIX}"

if [[ -z "${DOCKER_VOLUMES_PATH_PREFIX}" ]]; then
	echo "Error: \${DOCKER_VOLUMES_PATH_PREFIX} is empty/unset. Aborting..."
	exit 1
fi
if [[ ! "${DOCKER_VOLUMES_PATH_PREFIX}" =~ ^\.?\.?/([^/]+/)+$ ]]; then
	echo "Error: \${DOCKER_VOLUMES_PATH_PREFIX} is neither an absolute nor a relative path or does not end with a \"/\". Aborting..."
	exit 1
fi

mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}"             && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}"
mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}cache"        && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}cache"
mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}db-fcrepo"    && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}db-fcrepo"    && setfacl --modify="user:70:rwx" "${DOCKER_VOLUMES_PATH_PREFIX}db-fcrepo"
mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}db-app"       && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}db-app"       && setfacl --modify="user:70:rwx" "${DOCKER_VOLUMES_PATH_PREFIX}db-app"
mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}derivatives"  && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}derivatives"
mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}fcrepo"       && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}fcrepo"
mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}file_uploads" && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}file_uploads"
mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}redis"        && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}redis"        && setfacl --modify="user:999:rwx" "${DOCKER_VOLUMES_PATH_PREFIX}redis"    && setfacl --modify="group:999:rwx" "${DOCKER_VOLUMES_PATH_PREFIX}redis"
mkdir --mode=700 --parents "${DOCKER_VOLUMES_PATH_PREFIX}solr"         && chmod 700 "${DOCKER_VOLUMES_PATH_PREFIX}solr"         && setfacl --modify="user:8983:rwx" "${DOCKER_VOLUMES_PATH_PREFIX}solr"
